<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="知识库名" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入知识库名"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['fastGpt:fastGptDataset:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-edit"
          size="mini"
          @click="handleSync"
          v-hasPermi="['fastGpt:fastGptDataset:edit']"
        >同步知识库信息</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="fastGptDatasetList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="知识库id" align="center" prop="datasetId" />
      <el-table-column label="知识库名" align="center" prop="name" />
      <el-table-column label="介绍" align="center" prop="intro" />
      <el-table-column label="头像地址" align="center" prop="avatar">
        <template slot-scope="scope">
          <img :src="scope.row.avatar" style="height: 80px">
        </template>
      </el-table-column>
      <el-table-column label="是否私有" align="center" prop="isOwner">
        <template slot-scope="scope">
          {{ scope.row.isOwner === 0 ? '是' : '否' }}
        </template>
      </el-table-column>
      <el-table-column label="更新时间" align="center" prop="updateTime" width="180"/>
      <el-table-column label="创建时间" align="center" prop="createTime" width="180"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleCollection(scope.row.datasetId)"
          >集合管理</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['fastGpt:fastGptDataset:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加知识库列对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="父级ID" prop="parentid">
          <el-input v-model="form.parentid" placeholder="用于构建目录结构。通常可以为 null 或者直接不传。" />
        </el-form-item>
        <el-form-item label="类型" prop="type">
          <el-select v-model="form.type" placeholder="代表普通知识库和文件夹。不传则代表创建普通知识库。">
            <el-option
              v-for="item in typeOptions"
              :key="item.dictValue"
              :label="item.dictLabel"
              :value="item.dictValue"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="知识库名" prop="name">
          <el-input v-model="form.name" placeholder="请输入知识库名" />
        </el-form-item>
        <el-form-item label="介绍" prop="intro">
          <el-input type="textarea" :rows="3" v-model="form.intro" placeholder="请输入介绍" />
        </el-form-item>
        <el-form-item label="知识库头像" prop="avatar">
            <ImageUpload v-model="form.avatar"  type="image" :limit="1" :width="100" :height="100"  disabled/>
        </el-form-item>
        <el-form-item label="向量模型" prop="vectorModel">
          <el-input v-model="form.vectorModel" placeholder="请输入向量模型(建议传空，用系统默认的)" />
        </el-form-item>
        <el-form-item label="文本处理模型" prop="agentModel">
          <el-input v-model="form.agentModel" placeholder="请输入文本处理模型(建议传空，用系统默认的)" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import ImageUpload from '@/components/ImageUpload'
import { listFastGptDataset, getFastGptDataset, delFastGptDataset, addFastGptDataset, updateFastGptDataset, exportFastGptDataset } from "@/api/fastGpt/fastGptDataset";
import {syncDataset} from "../../../api/fastGpt/fastGptDataset";

export default {
  name: "FastGptDataset",
  components: {ImageUpload},
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 知识库列表格数据
      fastGptDatasetList: [],
      //知识库类型
      typeOptions: [
        { dictLabel: "普通知识库", dictValue: 'dataset' },
        { dictLabel: "文件夹", dictValue: 'folder' },
      ],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        parentid: null,
        type: null,
        name: null,
        intro: null,
        avatar: null,
        vectorModel: null,
        agentModel: null,
        permission: null,
        canWrite: null,
        isOwner: null,
        updateTime: null,
        createTime: null,
        companyId: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [
          { required: true, message: "名称不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询知识库列列表 */
    getList() {
      this.loading = true;
      listFastGptDataset(this.queryParams).then(response => {
        this.fastGptDatasetList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        datasetId: null,
        parentid: null,
        type: "dataset",
        name: null,
        intro: null,
        avatar: null,
        vectorModel: null,
        agentModel: null,
        permission: null,
        canWrite: null,
        isOwner: null,
        updateTime: null,
        createTime: null,
        companyId: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.datasetId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加知识库列";
    },
    handleSync(){
      syncDataset().then(res => {
        this.msgSuccess("同步成功");
        this.getList();
      })
    },
    //跳转到集合管理页面
    handleCollection(datasetId){
      this.$router.push('/fastGpt/fastGptDataset/Collection/fastGptCollection/'+datasetId)
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const datasetId = row.datasetId || this.ids
      getFastGptDataset(datasetId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改知识库列";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.datasetId != null) {
            updateFastGptDataset(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addFastGptDataset(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const datasetIds = row.datasetId || this.ids;
      this.$confirm('是否确认删除知识库列编号为"' + datasetIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delFastGptDataset(datasetIds);
        }).then((res) => {
          this.getList();
          if (res.data.length){
            this.msgError("部分删除失败:"+res.data);
          }else {
            this.msgSuccess("删除成功");
          }

        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有知识库列数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportFastGptDataset(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
